﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace Threads
{
    /// <summary>
    /// Interaktionslogik für MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, RoutedEventArgs e)
        {
            // 2
            System.Threading.Thread t = new System.Threading.Thread(doWork);
            t.Name = "Zähler";
            t.Priority = System.Threading.ThreadPriority.Lowest;
            //t.Start();

            // 3
            System.Threading.Thread t1 = new System.Threading.Thread(doWork1);
            t1.Name = "Zähler";
            t1.Priority = System.Threading.ThreadPriority.Lowest;
            t1.IsBackground = true;
            //t1.Start();

            // 4
            if (!isRunning)
            {
                mustStop = false;
                System.Threading.Thread t2 = new System.Threading.Thread(doWork2);
                t2.Name = "Zähler";
                t2.Priority = System.Threading.ThreadPriority.Lowest;
                isRunning = true;
                t2.Start();
            }
        }

        // 2
        void doWork()
        {
            for (int i = 0; i < 100000000; i++)
            {
                if (i % 10000000 == 0)
                {
                    System.Diagnostics.Trace.WriteLine(i / 10000000);
                }
            }
        }

        // 3
        void doWork1()
        {
            int i = 0;
            while (true)
            {
                i++;
                if (i > 10000000)
                {
                    i = 0;
                    System.Diagnostics.Trace.Write("*");
                }
            }
        }

        // 4
        volatile bool mustStop;
        volatile bool isRunning;
        //5
        volatile float x;

        // 4
        void doWork2()
        {
            int i = 0;
            while (!mustStop)
            {
                i++;
                // 5
                x = (float)(Math.PI * i);
                if (i > 10000000)
                {
                    i = 0;
                    System.Diagnostics.Trace.Write("*");
                }
            }
            isRunning = false;
        }

        // 4
        private void button2_Click(object sender, RoutedEventArgs e)
        {
            mustStop = true;
        }

        private void button3_Click(object sender, RoutedEventArgs e)
        {
            label1.Content = x;
        }
    }
}
