﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace Threads3
{
    /// <summary>
    /// Interaktionslogik für MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, RoutedEventArgs e)
        {
            lock (dummy)
            {
                zähler = 0;
            }

            System.Threading.Thread t1 = new System.Threading.Thread(doWork);
            t1.Priority = System.Threading.ThreadPriority.Lowest;
            t1.Start();

            System.Threading.Thread t2 = new System.Threading.Thread(doWork);
            t2.Priority = System.Threading.ThreadPriority.Lowest;
            t2.Start();
        }

        // 9
        // volatile int zähler;

        // 10
        object dummy = new object();
        int zähler;

        // 9 
        void doWork()
        {
            for (int i = 0; i < 10000000; i++)
            {
                lock (dummy) // 10
                {
                    zähler++;
                }
            }
            System.Diagnostics.Trace.WriteLine(zähler);
        }
    }
}
